%global dlrn_nvr oslo.policy-3.7.1-1.20220727124740.639b471
%global dlrn 1
%define upstream_version 3.7.1
%{!?sources_gpg: %{!?dlrn:%global sources_gpg 1} }
%global sources_gpg_sign 0x01527a34f0d0080f8a5db8d6eb6c5df21b4b6363
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global pypi_name oslo.policy
%global pkg_name oslo-policy
%global with_doc 0
%global common_desc \
An OpenStack library for policy.

%global common_desc1 \
Test subpackage for the Oslo policy library.

Name:           python-%{pkg_name}
Version: 3.7.1
Release: 1.20220727124740.639b471%{?dist}
Summary:        OpenStack oslo.policy library

License:        ASL 2.0
URL:            https://launchpad.net/oslo
Source0: oslo.policy-3.7.1-1.20220727124740.639b471.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=639b47198b3334c33f4675a9210c31922c50be52

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
Source101:        https://tarballs.openstack.org/%{pypi_name}/%{pypi_name}-%{upstream_version}.tar.gz.asc
Source102:        https://releases.openstack.org/_static/%{sources_gpg_sign}.txt
%endif
BuildArch:      noarch

# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
BuildRequires:  /usr/bin/gpgv2
BuildRequires:  openstack-macros
%endif

%description
%{common_desc}

%package -n python3-%{pkg_name}
Summary:        OpenStack oslo.policy library
%{?python_provide:%python_provide python3-%{pkg_name}}
Obsoletes: python2-%{pkg_name} < %{version}-%{release}

BuildRequires:  git-core
BuildRequires:  python3-devel
BuildRequires:  python3-pbr
# test dependencies
BuildRequires:  python3-hacking
BuildRequires:  python3-oslo-config
BuildRequires:  python3-oslo-context
BuildRequires:  python3-oslo-serialization
BuildRequires:  python3-oslotest
BuildRequires:  python3-fixtures
BuildRequires:  python3-mock
BuildRequires:  python3-requests
BuildRequires:  python3-stevedore
BuildRequires:  python3-stestr
BuildRequires:  python3-sphinx
# Required to compile translation files
BuildRequires:  python3-babel

BuildRequires:  python3-requests-mock
BuildRequires:  python3-docutils
BuildRequires:  python3-PyYAML >= 3.1.0

Requires:       python3-requests
Requires:       python3-oslo-config >= 2:5.2.0
Requires:       python3-oslo-context >= 2.22.0
Requires:       python3-oslo-i18n >= 3.15.3
Requires:       python3-oslo-serialization >= 2.18.0
Requires:       python3-stevedore >= 1.20.0
Requires:       python3-oslo-utils >= 3.40.0

Requires:       python3-yaml >= 5.1
Requires:       python-%{pkg_name}-lang = %{version}-%{release}

%description -n python3-%{pkg_name}
%{common_desc}

%if 0%{?with_doc}
%package -n python-%{pkg_name}-doc
Summary:    Documentation for the Oslo policy library

BuildRequires:  python3-sphinx
BuildRequires:  python3-sphinxcontrib-apidoc
BuildRequires:  python3-openstackdocstheme
BuildRequires:  python3-oslo-i18n

%description -n python-%{pkg_name}-doc
Documentation for the Oslo policy library.
%endif

%package -n python3-%{pkg_name}-tests
Summary:    Test subpackage for the Oslo policy library
%{?python_provide:%python_provide python3-%{pkg_name}}

Requires:  python3-%{pkg_name} = %{version}-%{release}
Requires:  python3-hacking
Requires:  python3-oslotest
Requires:  python3-fixtures
Requires:  python3-mock
Requires:  python3-requests

Requires:  python3-requests-mock

%description -n python3-%{pkg_name}-tests
%{common_desc1}

%package  -n python-%{pkg_name}-lang
Summary:   Translation files for Oslo policy library

%description -n python-%{pkg_name}-lang
Translation files for Oslo policy library

%prep
# Required for tarball sources verification
%if 0%{?sources_gpg} == 1
%{gpgverify}  --keyring=%{SOURCE102} --signature=%{SOURCE101} --data=%{SOURCE0}
%endif
%autosetup -n %{pypi_name}-%{upstream_version} -S git
# Let RPM handle the dependencies
rm -f *requirements.txt

# FIXME (jpena): Remove buggy PO-Revision-Date lines in translation
# See https://bugs.launchpad.net/openstack-i18n/+bug/1586041 for details
sed -i '/^\"PO-Revision-Date: \\n\"/d' oslo_policy/locale/*/LC_MESSAGES/*.po

%build
%{py3_build}

%if 0%{?with_doc}
# generate html docs
# NOTE(jcapitao): we can re-enable warnings-as-failures once
# https://review.opendev.org/#/c/669427/ is in a tagged release
sphinx-build-3 -b html doc/source doc/build/html
# Fix hidden-file-or-dir warnings
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

# Generate i18n files
python3 setup.py compile_catalog -d build/lib/oslo_policy/locale --domain oslo_policy

%install
%{py3_install}
pushd %{buildroot}/%{_bindir}
for item in checker list-redundant policy-generator sample-generator
do
  # Create a versioned binary for backwards compatibility until everything is pure py3
  ln -s oslopolicy-$item %{buildroot}%{_bindir}/oslopolicy-$item-3
done
popd

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python3_sitelib}/oslo_policy/locale/*/LC_*/oslo_policy*po
rm -f %{buildroot}%{python3_sitelib}/oslo_policy/locale/*pot
mv %{buildroot}%{python3_sitelib}/oslo_policy/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang oslo_policy --all-name

%check
export OS_TEST_PATH="./oslo_policy/tests"
# Exclude test_generator_raises_error until https://review.opendev.org/#/c/741869/ is tag released
PYTHON=python3 stestr-3 --test-path $OS_TEST_PATH run --black-regex test_generator_raises_error

%files -n python3-%{pkg_name}
%doc README.rst
%license LICENSE
%{_bindir}/oslopolicy-policy-upgrade
%{_bindir}/oslopolicy-checker
%{_bindir}/oslopolicy-checker-3
%{_bindir}/oslopolicy-convert-json-to-yaml
%{_bindir}/oslopolicy-list-redundant
%{_bindir}/oslopolicy-list-redundant-3
%{_bindir}/oslopolicy-policy-generator
%{_bindir}/oslopolicy-policy-generator-3
%{_bindir}/oslopolicy-sample-generator
%{_bindir}/oslopolicy-sample-generator-3
%{_bindir}/oslopolicy-validator
%{python3_sitelib}/oslo_policy
%{python3_sitelib}/*.egg-info
%exclude %{python3_sitelib}/oslo_policy/tests

%if 0%{?with_doc}
%files -n python-%{pkg_name}-doc
%doc doc/build/html
%license LICENSE
%endif

%files -n python3-%{pkg_name}-tests
%{python3_sitelib}/oslo_policy/tests

%files -n python-%{pkg_name}-lang -f oslo_policy.lang
%license LICENSE

%changelog
* Wed Jul 27 2022 OSP Prod Chain <dev-null@redhat.com> 3.7.1-1.20220727124740.639b471
- Update patches

* Tue Jul 12 2022 OSP Prod Chain <dev-null@redhat.com> 3.7.1-0.20220712161700.639b471
- Update patches

* Sun Jan 23 2022 OSP Prod Chain <dev-null@redhat.com> 3.7.1-0.20220123081833.639b471
- Update patches
- Map system_scope in creds dictionary
- Update TOX_CONSTRAINTS_FILE for stable/wallaby
- Update .gitreview for stable/wallaby
- Move flake8 as a pre-commit local target.

* Thu May 27 2021 OSP Prod Chain <dev-null@redhat.com> 3.7.0-0.20210527205802.d853485
- Update patches

* Wed Mar 24 2021 OSP Prod Chain <dev-null@redhat.com> 3.7.0-1
- Update patches

* Sat Mar 13 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Mar 05 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- trivial: Tweak docstrings
- Make 'Rule' attributes read-only
- Don't modify 'Rule.check'
- Add nova/neutron project unit/functional tests job in gate
- Add documentation parameters for DeprecatedRule
- tests: Unset requests-related environment variables
- remove unicode from code

* Tue Feb 16 2021 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Work on copy of registered rule instead of original object
- Handle deprecated rule only once
- Switch to collections.abc.MutableMapping
- pre-commit: Resolve dependency conflicts
- Use TOX_CONSTRAINTS_FILE

* Tue Dec 15 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Dec 04 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix oslopolicy-j2y-convertor tool for RuleDefault
- Add policy file selection logic when default changing to yaml
- Fix grammar issues
- Remove format option examples in policy generator
- Fix hacking min version to 3.0.1
- Remove all usage of six library
- Adding pre-commit
- Add Python3 wallaby unit tests
- Update master for stable/victoria

* Fri Nov 20 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Oct 21 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Fri Sep 18 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- [goal] Migrate testing to ubuntu focal
- sample-generator: Improve YAML output

* Tue Sep 08 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Log warning for redundant file rules
- Deprecate the JSON support for policy_file
- Add oslopolicy-convert-json-to-yaml tool
- Bump bandit version
- Clarify what exactly an "access file" is

* Wed Jul 29 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix unit tests to work with stevedore > 2.0.1

* Thu Jul 23 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Don't deepcopy objects before mask_dict_password
- Include example of literal comparison policy rule

* Thu Jul 23 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Tue Jul 14 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- docs: Add separate man page for each CLI tool
- Add oslopolicy-validator tool
- Align contributing doc with oslo's policy

* Tue Jun 30 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Reload files in policy_dirs on primary file change
- Fix pygments style

* Fri Jun 05 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Switch to newer openstackdocstheme and reno versions
- Remove the unused coding style modules
- Remove translation sections from setup.cfg
- docs: Add description of 'oslopolicy-policy-generator'
- Bump default tox env from py37 to py38
- Add py38 package metadata
- Add release notes links to doc index
- Add Python3 victoria unit tests
- Update master for stable/ussuri
- Mark sphinx extensions thread safe
- Remove the conversion according to the comment of jdennis

* Fri Jun 05 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon May 04 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Fix doc comments for new enforce default flag

* Mon Apr 27 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Allow disabling the default check_str change warnings
- Add new config to enforce the new defaults
- Cleanup warnings
- Bump oslo.utils to 3.40.0

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Mon Apr 13 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Use unittest.mock instead of third party mock
- Update hacking for Python3

* Thu Mar 26 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Don't parse cli args on the global object in sphinxpolicygen

* Mon Mar 23 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Temporarily make namespace arg optional
- remove outdated header
- [ussuri][goal] Drop python 2.7 support and testing
- Link to the Keystone role documentation
- Make HTTP check doc heading more specific
- Initialize global config object in cli tools
- Move away from python setup.py test who is deprecated in pbr
- tox: Trivial cleanup
- Follow the new PTI for document build

* Thu Mar 19 2020 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches

* Wed Dec 18 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Don't use string processing to combine deprecated rules
- Merge "Bump the openstackdocstheme extension to 1.20"
- Merge "Switch to Ussuri jobs"
- Bump the openstackdocstheme extension to 1.20
- Switch to Ussuri jobs

* Mon Dec 02 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "tox: Keeping going with docs"
- Merge "Modernize policy checker"
- tox: Keeping going with docs
- Merge "Suppress deprecation warnings in oslopolicy-list-redundant"
- Modernize policy checker
- Merge "Update master for stable/train"
- Update the constraints url
- Update master for stable/train
- Suppress deprecation warnings in oslopolicy-list-redundant
- Fix reference cycle caused by deprecated sample override

* Wed Nov 13 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches


